version: '3.8'

services:
  op-geth-minato:
    image: us-docker.pkg.dev/oplabs-tools-artifacts/images/op-geth:v1.101503.2
    entrypoint: >
      geth --datadir=/data/optimism --http --http.corsdomain=* --http.vhosts=* 
      --http.addr=0.0.0.0 --http.api=web3,debug,eth,txpool,net,engine --ws 
      --ws.addr=0.0.0.0 --ws.port=8546 --ws.origins=* --ws.api=debug,eth,txpool,net,engine 
      --syncmode=full --gcmode=archive --maxpeers=100 --authrpc.vhosts=* 
      --authrpc.addr=0.0.0.0 --authrpc.port=8551 --authrpc.jwtsecret=/etc/optimism/jwt.txt --metrics 
      --metrics.addr=0.0.0.0 --metrics.expensive --metrics.port=6060 
      --rollup.disabletxpoolgossip=false --rpc.allow-unprotected-txs=true --db.engine=pebble --state.scheme=hash 
      --port=30303 
      --bootnodes=enode://3b374fde1c0c766f521b54dbbbe7f9eabf906392e1bc4d7e7935e59f48a10852ba9ac301a0aab7de39ed219338e62ac904749a1fb26e48565836793cfe070d8a@35.72.109.28:30303,enode://17282ca4df935246fff38dc2309f028c646c68e32f957e1a381682912d94e87c14260b1c19ce42708fd2b71fbb115fce03399433dd8af5faf5420eb1b07baa34@54.92.122.135:30303,enode://4c88742e5804ffe17eeee38e54a2e2a1f095639ac7b334bf3e9b772b730505d6c3ae34d41ae208805b6fe5b76755c9007896656bdf1e06c66a11dc69adbb3a30@52.193.252.228:30303
      --op-network=soneium-minato-sepolia
    ports:
      - "8551:8551"
      - "6060:6060"
      - "8545:8545"
      - "8546:8546"
      - "30303:30303" 
    volumes:
      - op-geth-storage:/data/optimism
      - ./jwt.txt:/etc/optimism/jwt.txt
      - op-secrets:/etc/minato/secrets
    networks:
      - minato

  op-node-minato:
    image: us-docker.pkg.dev/oplabs-tools-artifacts/images/op-node:v1.13.0
    environment:
      - L1_URL
      - L2_URL
      - RPC_ADDR
      - RPC_PORT
      - L2_JWT_SECRET
      - L1_TRUST_RPC
      - L1_BEACON
      - SYNC_MODE
      - L1_RPC_KIND
      - OP_NODE_STATIC_PEERS
      - P2P_PRIV_PATH
      - P2P_DISCOVERY_PATH
      - P2P_PEERSTORE_PATH
      - P2P_ADVERTISE_IP
      - OP_NODE_P2P_PEER_BANNING
      - METRICS_ENABLED
      - METRICS_PORT
    command: >
      op-node --l1=${L1_URL} --l2=${L2_URL} --rpc.addr=${RPC_ADDR} --rpc.port=${RPC_PORT}
      --l2.jwt-secret=${L2_JWT_SECRET} --l1.trustrpc=${L1_TRUST_RPC} --l1.beacon=${L1_BEACON}
      --syncmode=${SYNC_MODE} --l1.rpckind=${L1_RPC_KIND} --p2p.static=${OP_NODE_STATIC_PEERS}
      --p2p.priv.path=${P2P_PRIV_PATH} --p2p.discovery.path=${P2P_DISCOVERY_PATH} 
      --p2p.peerstore.path=${P2P_PEERSTORE_PATH} --metrics.enabled=${METRICS_ENABLED}
      --p2p.ban.peers=${OP_NODE_P2P_PEER_BANNING}
      --p2p.bootnodes=enr:-J24QF115OWADQGBt9G4hUTTYiBxZgYNzzzRpB2npFOmNk6IN89NkYIflCBr9hlbJbn2ClLMgAv-8dLJ8l9hn11hOMqGAZawx9oFgmlkgnY0gmlwhCNIbRyHb3BzdGFja4OaDwCJc2VjcDI1NmsxoQIm5ef5q7HLiFm2yu6fsWsCvxF99555NNZm2EvAcP8cJ4N0Y3CCJAaDdWRwgiQH,enr:-J24QIgqtFPdNjPRjcHr_J_puVeY_OVFXAUBTGcKWZeBGEFoY2KFLK2eT0a8NhWZROrl-rDwN2Fx0X6WAaqcmNLu8cyGAZaRwqxWgmlkgnY0gmlwhDZceoeHb3BzdGFja4OaDwCJc2VjcDI1NmsxoQI17LgPPkjI3_ASk_JvdUNbgpg8uUv4y4HV8uErOvwAEoN0Y3CCJAaDdWRwgiQH,enr:-J24QFea5V1F2sp1vXGsLYyyGgq10OK5E2n8pErQJtu0qU4AIQQRiOcnwKKDoauahQgXmZhpZafSr-jIDc1OxbWhQwuGAZbzWFAVgmlkgnY0gmlwhDTB_OSHb3BzdGFja4OaDwCJc2VjcDI1NmsxoQNXOdzEtjWW7gMBpImPoDh1o15_cn4ufgpUmh_teSz4NIN0Y3CCJAaDdWRwgiQH
      --metrics.port=${METRICS_PORT}
      --network=soneium-minato-sepolia
    ports:
      - "9545:9545"
      - "7310:7310"
      - "9222:9222"
    volumes:
      - op-node-storage:/data/optimism
      - ./jwt.txt:/etc/optimism/jwt.txt
      - op-secrets:/etc/minato/secrets
    networks:
      - minato

volumes:
  op-geth-storage:
  op-node-storage:
  op-secrets:

networks:
  minato:
    driver: bridge

